> For the complete documentation index, see [llms.txt](https://docs.sonarsource.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.sonarsource.com/sonarqube-server/analyzing-source-code/ci-integration/codemagic-integration.md).

# Codemagic

Information on setting up Codemagic with SonarQube Server 2026.5.

SonarScanners running in Codemagic can automatically detect branches and merge or pull requests in certain jobs. You don’t need to explicitly pass the branch or pull request details.

## Adding SonarQube Server scripts to your Codemagic .yml file <a href="#codemagic" id="codemagic"></a>

To analyze your code when using Codemagic:

* Add the following scripts to your existing `codemagic.yaml` file:

```yaml
scripts:   
   - |
       # download and install the SonarScanner
       wget -O $FCI_BUILD_DIR/sonar-scanner.zip https://binaries.sonarsource.com/Distribution/sonar-scanner-cli/sonar-scanner-cli-4.4.0.2170-macosx.zip
       # If running in a Linux environment, download https://binaries.sonarsource.com/Distribution/sonar-scanner-cli/sonar-scanner-cli-4.4.0.2170-linux.zip 
       unzip $FCI_BUILD_DIR/sonar-scanner.zip
       mv sonar-scanner-* sonar-scanner
  - |
       # Generate and upload code analysis report
       export PATH=$PATH:$FCI_BUILD_DIR/sonar-scanner/bin
       sonar-scanner \
       -Dsonar.projectKey=YOUR_PROJECT_KEY \
       -Dsonar.host.url=SONARQUBE_URL \
```

* Define `SONAR_TOKEN` as a Codemagic environment variable.

## Automatically detecting pull requests <a href="#detecting-pull-requests" id="detecting-pull-requests"></a>

For SonarQube Server to automatically detect pull requests when using Codemagic, you need to add an event in the triggering section of your `codemagic.yaml` file as shown in the following snippet:

```yaml
    triggering:
      events:
        - pull_request
```

For triggering to work, you also need to set up a link between Codemagic and your DevOps platform (Bitbucket, Github, etc.). See the [Codemagic documentation](https://docs.codemagic.io/configuration/webhooks/) for more information.

## Caching the .sonar folder <a href="#sonar-folder" id="sonar-folder"></a>

Caching the `.sonar` folder saves time on subsequent analyses. To do this, add the following snippet to your `codemagic.yaml` file:

```yaml
    cache:
      cache_paths:
        - ~/.sonar
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.sonarsource.com/sonarqube-server/analyzing-source-code/ci-integration/codemagic-integration.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
